package com.sun.org.apache.bcel.internal.classfile;

import java.io.DataOutputStream;
import java.io.IOException;
import java.io.DataInput;

public final class ConstantInteger extends Constant implements ConstantObject
{
    private int bytes;
    
    public ConstantInteger(int bytes) {
        super((byte)3);
        this.bytes = bytes;
    }
    
    public ConstantInteger(ConstantInteger c) {
        this(c.getBytes());
    }
    
    ConstantInteger(DataInput file) throws IOException {
        this(file.readInt());
    }
    
    @Override
    public void accept(Visitor v) {
        v.visitConstantInteger(this);
    }
    
    @Override
    public final void dump(DataOutputStream file) throws IOException {
        file.writeByte((int)super.getTag());
        file.writeInt(this.bytes);
    }
    
    public final int getBytes() {
        return this.bytes;
    }
    
    public final void setBytes(int bytes) {
        this.bytes = bytes;
    }
    
    @Override
    public final String toString() {
        return super.toString() + "(bytes = " + this.bytes + ")";
    }
    
    @Override
    public Object getConstantValue(ConstantPool cp) {
        return Integer.valueOf(this.bytes);
    }
}
